require 'base64'
require 'faraday'
require 'json'

module Diplomat
  class Client < Diplomat::RestClient

    @@config = {}


    # parse configuration
    # @param directory [String] location of consult client configuration files
    # @return [OpenStruct] all data associated with the service
    def config directory

      services = []
      Dir.glob("#{directory}/*.json") do |json_file|
        # do work on files ending in .rb in the desired directory
        file = File.read(json_file)
        data_hash = JSON.parse(file)
        data_hash.each do |key, array|
          if key.casecmp("service") == 0
            services.push(array)
          else
            @@config[key] = array
          end
        end
      end
      @@config["services"] = services
      return @@config
    end

    # @note This is sugar, see (#get)
    def self.config *args
      Diplomat::Client.new.config *args
    end

  end
end
